#ifndef _EVENTLOGEXAMPLE_H
#define _EVENTLOGEXAMPLE_H

#include <DsLogAdminC.h>
#include <DsEventLogAdminC.h>
#include <CosEventCommC.h>
#include <CosEventCommS.h>
#include <CosEventChannelAdminC.h>

#include <tao/corba.h>
#include <ace/OS.h>

#include <Common/ObjectAdapter.h>

#include "macro.h"


class EventLogExample : public POA_CosEventComm::PushSupplier
{
  public:

    EventLogExample (CORBA::ORB_var orbVar, ObjectAdapter *pAadapter);

    ~EventLogExample ();

    DsEventLogAdmin::EventLog_ptr create ();

    void connect (DsEventLogAdmin::EventLog_ptr channel);

    void generate ();

    void disconnect ();

    void disconnect_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

  protected:

  private:

    CORBA::ORB_var orbVar_;

    ObjectAdapter *pAdapter_;

    DsEventLogAdmin::EventLogFactory_var eventLogFactoryVar_;

    CosEventChannelAdmin::ProxyPushConsumer_var proxyVar_;
};

#endif
