#ifndef _NOTIFYLOGEXAMPLE_H
#define _NOTIFYLOGEXAMPLE_H

#include <DsLogAdminC.h>
#include <DsNotifyLogAdminC.h>
#include <CosNotificationC.h>
#include <CosNotifyCommC.h>
#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminC.h>
#include <CosNotifyFilterC.h>

#include <tao/corba.h>
#include <ace/OS.h>

#include <Common/ObjectAdapter.h>

#include "macro.h"


class NotifyLogExample : public POA_CosNotifyComm::PushSupplier
{
  public:

    NotifyLogExample (CORBA::ORB_var orbVar, ObjectAdapter *pAdapter);
    
    ~NotifyLogExample ();

    DsNotifyLogAdmin::NotifyLog_ptr create ();

    void setFilter (DsNotifyLogAdmin::NotifyLog_ptr channel);

    void connect (DsNotifyLogAdmin::NotifyLog_ptr channel);

    void generate ();

    void disconnect ();

    void disconnect_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void subscription_change (CosNotification::EventTypeSeq const & /*added*/, CosNotification::EventTypeSeq const & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

  protected:

  private:

      CORBA::ORB_var orbVar_;

      ObjectAdapter *pAdapter_;

      DsNotifyLogAdmin::NotifyLogFactory_var notifyLogFactoryVar_;

      CosNotifyChannelAdmin::ProxyPushConsumer_var proxyVar_;
};

#endif // _NOTIFYLOGEXAMPLE_H
