/*
 * Account implementation.
 */

#include "AccountImpl.h"


AccountImpl::AccountImpl (const char *name, CORBA::Float balance)
  : POA_Bank::Account (), name_ (0), balance_ (balance)
{
  name_ = ACE_OS::strdup (name);
}

AccountImpl::~AccountImpl ()
{
}

char *
AccountImpl::name ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return ACE_OS::strdup (name_);
}

CORBA::Float
AccountImpl::balance ()
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return balance_;
}

void
AccountImpl::deposit (CORBA::Float amount)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  balance_ += amount;
}

void
AccountImpl::withdraw (CORBA::Float amount)
  ACE_THROW_SPEC ((CORBA::SystemException, Bank::Account::InsufficientFunds))
{
  if (amount > balance_)
    {
      ACE_DEBUG ((LM_ERROR, ACE_TEXT ("ERROR: Amount requested (%.2f) exceeds available balance of %.2f\n"), amount, balance_));
      ACE_THROW (Bank::Account::InsufficientFunds ());
    }
  else
    {
      balance_ -= amount;
    }
}
