#ifndef _ACCOUNTIMPL_H
#define _ACCOUNTIMPL_H

#include "BankS.h"
#include "BankC.h"

#include <tao/corba.h>
#include <ace/OS.h>

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL AccountImpl : public POA_Bank::Account
{
  public:

    AccountImpl (const char* name, CORBA::Float balance);

    ~AccountImpl ();

    char *name ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    CORBA::Float balance ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void deposit (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException));

    void withdraw (CORBA::Float amount)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::Account::InsufficientFunds));

  protected:
  
  private:

    char *name_;

    CORBA::Float balance_;
};

#endif // _ACCOUNTIMPL_H
