#ifndef _ACCOUNTMANAGERIMPL_H
#define _ACCOUNTMANAGERIMPL_H

#include "BankS.h"
#include "BankC.h"

#include <tao/corba.h>
#include <ace/OS.h>

#include "AccountImpl.h"
#include "Util.h"

#ifndef OPENFUSION_BANK_DLL
#define OPENFUSION_BANK_DLL
#endif

class OPENFUSION_BANK_DLL AccountManagerImpl : public POA_Bank::AccountManager
{
  public:

    AccountManagerImpl (Util *pUtil);

    ~AccountManagerImpl () {}

    virtual void createAccount (const char *name, CORBA::Float amount ACE_ENV_ARG_DECL)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::AccountManager::AlreadyExists));

    virtual Bank::Account_ptr getAccount (const char *name ACE_ENV_ARG_DECL)
      ACE_THROW_SPEC ((CORBA::SystemException, Bank::AccountManager::NotFound));

  protected:

  private:

    Util *pUtil_;
};

#endif // _ACCOUNTMANAGERIMPL_H

