#ifndef _NEWSPUBLISHER_H
#define _NEWSPUBLISHER_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "Notification/news/ChannelUtil.h"


class NewsPublisher : public POA_CosNotifyComm::StructuredPushSupplier
{
  public:

    NewsPublisher (CORBA::ORB_var orbVar);

    ~NewsPublisher ();

    void connectToChannel ();

    void broadcast ();

    void delay ();

    virtual CosNotification::StructuredEvent createNextEvent () = 0;

    void disconnect_structured_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void subscription_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType, CORBA::SystemException));

  protected:

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::StructuredPushSupplier_var supplierVar_;

    CosNotifyChannelAdmin::StructuredProxyPushConsumer_var proxyVar_;

    int eventCount_;

    long maxDelay_;

  private:

};
#endif  // _NEWSPUBLISHER_H
