#ifndef _NEWSSUBSCRIBER_H
#define _NEWSSUBSCRIBER_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "Notification/news/ChannelUtil.h"


class NewsSubscriber : public POA_CosNotifyComm::StructuredPushConsumer
{
  public:

    NewsSubscriber (CORBA::ORB_var orbVar);

    ~NewsSubscriber ();

    void connectToChannel ();

    virtual void select (const char *bureau) = 0;

    void setFilter (const char *domainName, const char *typeName, const char *constraint);

    void disconnect_structured_push_consumer ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void offer_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType, CORBA::SystemException));

    void push_structured_event (const CosNotification::StructuredEvent& event)
      ACE_THROW_SPEC ((CosEventComm::Disconnected,CORBA::SystemException));

  protected:

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyChannelAdmin::EventChannel_var channelVar_;

    CosNotifyComm::StructuredPushConsumer_var consumerVar_;

    CosNotifyChannelAdmin::StructuredProxyPushSupplier_var proxyVar_;

  private:

};
#endif  // _NEWSSUBSCRIBER_H
