#ifndef _SEQUENCEPUSHSUPPLIER_H
#define _SEQUENCEPUSHSUPPLIER_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"


class SequencePushSupplierImpl : public POA_CosNotifyComm::SequencePushSupplier
{
  public:

    SequencePushSupplierImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~SequencePushSupplierImpl ();

    void disconnect_sequence_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void subscription_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void pushEvents ();

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::SequencePushSupplier_var supplierVar_;

    CosNotifyChannelAdmin::SequenceProxyPushConsumer_var proxyVar_;
};

#endif // _SEQUENCEPUSHSUPPLIER_H
