#ifndef _STRUCTUREDPUSHSUPPLIERIMPL_H
#define _STRUCTUREDPUSHSUPPLIERIMPL_H

#include <CosNotifyCommS.h>
#include <CosNotifyChannelAdminS.h>
#include <CosNotificationS.h>

#include "ChannelUtil.h"


class StructuredPushSupplierImpl : public POA_CosNotifyComm::StructuredPushSupplier
{
  public:

    StructuredPushSupplierImpl (CORBA::ORB_var orbVar, ChannelUtil *pUtil);

    ~StructuredPushSupplierImpl ();

    void disconnect_structured_push_supplier ()
      ACE_THROW_SPEC ((CORBA::SystemException));

    void subscription_change (const CosNotification::EventTypeSeq & /*added*/, const CosNotification::EventTypeSeq & /*removed*/)
      ACE_THROW_SPEC ((CosNotifyComm::InvalidEventType,CORBA::SystemException));

    void pushEvents ();

  protected:

  private:

    void connectToChannel ();

    CORBA::ORB_var orbVar_;

    ChannelUtil *pUtil_;

    CosNotifyComm::StructuredPushSupplier_var supplierVar_;

    CosNotifyChannelAdmin::StructuredProxyPushConsumer_var proxyVar_;
};

#endif // _STRUCTUREDPUSHSUPPLIERIMPL_H
